package com.yunzhi.inte.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.yunzhi.inte.entity.Store;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.yunzhi.inte.entity.FoodIngredients;
import com.yunzhi.inte.mapper.FoodIngredientsMapper;
import com.yunzhi.inte.service.FoodIngredientsService;

import java.util.ArrayList;
import java.util.List;

/**
 * 菜肴食材;(food_ingredients)表服务实现类
 * @author : http://www.chiner.pro
 * @date : 2022-9-17
 */
@Service
public class FoodIngredientsServiceImpl extends BaseServiceImpl<FoodIngredientsMapper, FoodIngredients> implements FoodIngredientsService {

    @Override
    public IPage<Store> getByDish(IPage<Store> pg, Integer dishId) {
        return baseMapper.getByDish(pg, dishId);
    }

    @Override
    public void addOrUpdate(Integer dishId, List<Integer> ingredientsList) {
        // 查询已有 list
        List<Integer> idList = new ArrayList<>();
        if (null != ingredientsList && ingredientsList.size() > 0) {
            //
            for (Integer itemId: ingredientsList) {
                FoodIngredients item = baseMapper.getByDishAndItem(dishId, itemId);

                if (item != null) {
                    // 有就更新
                    updateById(item);
                } else {
                    // 没有就插入
                    item = new FoodIngredients();
                    item.setItemId(itemId);
                    item.setDishId(dishId);
                    save(item);
                }
                Integer id = item.getId();
                idList.add(id);
            }
        } else {
            idList.add(-1);
        }
        // 删除剩余的
        baseMapper.deleteNotExist(idList);
    }

    @Override
    public List<Integer> getItemListByDish(Integer dishId) {
        return baseMapper.getItemListByDish(dishId);
    }
}